// VSTp̃CN[ht@C
#include "myvst3.h"

// ===================================================================================
// DLLt@C̏AI֐
// ===================================================================================
bool InitModule() { return true; }
bool DeinitModule() { return true; }

// ===================================================================================
// VSTvOC̐
// ===================================================================================
BEGIN_FACTORY_DEF(MYVST_VENDOR, MYVST_URL, MYVST_EMAIL)

	// MyVSTProcessorNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ProcessorUID),
	PClassInfo::kManyInstances,
	kVstAudioEffectClass,
	MYVST_VSTNAME,
	Vst::kDistributable,
	MYVST_SUBCATEGORIES,
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTProcessor::createInstance)

	// MyVSTControllerNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ControllerUID),
	PClassInfo::kManyInstances,
	kVstComponentControllerClass,
	MYVST_VSTNAME " Controller",// VST̖O"Controller"t^́B
	0,                          // gȂ̂ŕK0ɂ
	"",                         // gȂ̂ŕK""ɂ
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTController::createInstance)

END_FACTORY

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// ===================================================================================
// MProcessorNX
// ===================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷(K{)
	setControllerClass(ControllerUID);
}

// NX֐
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{(K{)
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂ݒ
		addAudioInput(STR16("AudioInput"), SpeakerArr::kStereo);
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		// Kv΂̌AŗL̏{B
	}

	// kResultTrueԂB
	return result;
}


tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// p[^[ύX̏
	if (data.inputParameterChanges != nullptr)
	{
		// ύXꂽp[^[̐擾A̕
		int32 paramChangeCount = data.inputParameterChanges->getParameterCount();
		for (int32 i = 0; i < paramChangeCount; i++)
		{
			// p[^[ύX̃L[擾
			IParamValueQueue* queue = data.inputParameterChanges->getParameterData(i);
			if (queue != nullptr)
			{
				// ǂ̃p[^[ύXꂽm邽߁Ap[^[^O擾
				int32 tag = queue->getParameterId();

				// ύXꂽ񐔂擾
				int32 valueChangeCount = queue->getPointCount();

				// ŌɕύXꂽl擾
				ParamValue value;
				int32 sampleOffset;
				if (queue->getPoint(valueChangeCount - 1, sampleOffset, value) == kResultTrue)
				{
					// tagɉ{
					switch (tag)
					{
					case TYPE:
						type = (int32)(value * 3.0f);
						break;
					case DEPTH:
						depth = value;
						break;
					case FREQ:
						freq = (29.5f * value) + 0.5f; // 0.5`30.0̊ԂɕύX
						break;
					}
				}
			}
		}
	}

	// ͂Əo͂`FbN
	if (data.numInputs != 1 || data.numOutputs != 1)
	{
		return kResultTrue;
	}
	
	if (data.inputs[0].numChannels != 2 || data.outputs[0].numChannels != 2)
	{
		return kResultTrue;
	}


	// ́Eo̓obt@̃|C^킩₷ϐɊi[
	Sample32* inL = data.inputs[0].channelBuffers32[0];
	Sample32* inR = data.inputs[0].channelBuffers32[1];
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		// ͐MɊ|킹邽߂̔g`thetavZ
		Sample32 a = 1.0f;
		switch (type)
		{
		case 0: // TCg̏ꍇ
			// sin֐̒lvZBʂ0`1̊ԂɂȂ悤ɂ
			a = ((float)sin(theta) * 0.5f) + 0.5f;
			break;
		case 1: // Opg̏ꍇ
			// sin֐̌ʂt֐(asin)ɓnƎOpgɂȂB
			a = ((float)asin(sin(theta)) * 0.5f) + 0.5f;
			break;
		case 2: // `g̏ꍇ
			// sin֐̌ʂ0ȏ̏ꍇ1.0Ƃ邱Ƃŋ`gɂȂB
			a = (sin(theta) >= 0.0) ? (1.0f) : (0.0f);
			break;
		case 3: // mRMg̏ꍇ
			// theta2΂Ŋ]肪U 0`2 ̋`gɂȂB
			a = fmod(theta, 2.0 * 3.14159265) / (2.0 * 3.14159265);
			break;
		}

		// depthƔg` a͐MɊ|킹lvZ
		Sample32 b = (1.0f - depth) + (a * depth);

		// ͐Mb|킹
		outL[i] = b * inL[i];
		outR[i] = b * inR[i];

		// pxthetaɊpxčXV
		theta += (2.0 * 3.14159265 * freq) / 44100.0;
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}

// NX̏Ԃۑ֐
tresult PLUGIN_API MyVSTProcessor::getState(IBStream* state)
{
	// f[^ۑ
	state->write(&type, sizeof(int32));
	state->write(&depth, sizeof(ParamValue));
	state->write(&freq, sizeof(ParamValue));

	// ֐̏ɖ肪ȂkResultOkԂ
	return kResultOk;
}

// NX̏Ԃǂݍފ֐
tresult PLUGIN_API MyVSTProcessor::setState(IBStream* state)
{
	// ۑĂf[^ǂݍ
	tresult res;
	res = state->read(&type,  sizeof(int32));
	if (res != kResultOk) { return kResultFalse; }

	res = state->read(&depth, sizeof(ParamValue));
	if (res != kResultOk) { return kResultFalse; }

	res = state->read(&freq,  sizeof(ParamValue));
	if (res != kResultOk) { return kResultFalse; }

	// ֐̏ɖ肪ȂkResultOkԂ
	return kResultOk;
}

// ===================================================================================
// VST̃p[^[𐧌䂷邽߂ControllerNX
// ===================================================================================

// NX֐(K{)
tresult PLUGIN_API MyVSTController::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = EditController::initialize(context);
	if (result == kResultTrue)
	{
		// ͈̓p[^[쐬Ap[^[NXɒǉ
		RangeParameter* param1 = new RangeParameter(STR16("Depth"), DEPTH, STR16(""), 0.0, 1.0, 0.8);
		parameters.addParameter(param1);

		// ͈̓p[^[쐬Ap[^[NXɒǉ
		RangeParameter* param2 = new RangeParameter(STR16("Speed"), FREQ, STR16("Hz"), 0.5, 30.0, 2.0);
		parameters.addParameter(param2);

		// 񃊃Xgp[^[쐬AXgǉ
		StringListParameter* param3 = new StringListParameter(STR16("Type"), TYPE);
		param3->appendString(STR16("sine"));  // Xgڂǉ
		param3->appendString(STR16("triangle"));
		param3->appendString(STR16("square"));
		param3->appendString(STR16("saw"));
		// 񃊃Xgp[^[p[^[NXɒǉ
		parameters.addParameter(param3);
	}

	// kResultTrueԂB
	return result;
}

// NX̏Ԃۑ֐
tresult PLUGIN_API MyVSTController::getState(IBStream* state)
{
	return kResultOk;
}

// NX̏Ԃǂݍފ֐
tresult PLUGIN_API MyVSTController::setState(IBStream* state)
{
	return kResultOk;
}


// NXɉNX̏Ԃǂݍފ֐
tresult PLUGIN_API MyVSTController::setComponentState(IBStream* state)
{
	tresult res;

	// ۑĂf[^ǂݍ
	int32 tmptype;
	res = state->read(&tmptype, sizeof(int32));
	if (res != kResultOk) { return kResultFalse; }

	ParamValue tmpdepth;
	res = state->read(&tmpdepth, sizeof(ParamValue));
	if (res != kResultOk) { return kResultFalse; }

	ParamValue tmpfreq;
	res = state->read(&tmpfreq, sizeof(ParamValue));
	if (res != kResultOk) { return kResultFalse; }

	// ǂݍ܂ꂽf[^p[^ɔf
	// ff[^0.0`1.0͈̔͂ɂ
	ParamValue normalvalue = plainParamToNormalized(TYPE, (ParamValue)tmptype);
	setParamNormalized(TYPE, normalvalue);

	normalvalue = plainParamToNormalized(DEPTH, tmpdepth);
	setParamNormalized(DEPTH, normalvalue);

	normalvalue = plainParamToNormalized(FREQ, tmpfreq);
	setParamNormalized(FREQ, normalvalue);

	// ֐̏ɖ肪ȂkResultOkԂ
	return kResultOk;
}

// VSTvOCŗL̑(GUI)쐬֐
IPlugView* PLUGIN_API MyVSTController::createView(FIDString name)
{
	if (strcmp(name, ViewType::kEditor) == 0)
	{
		return new VSTGUI::VST3Editor(this, "view", "myEditor.uidesc");
	}
	return nullptr;
}

} } // namespace SteinbergVst̏I
