// VSTp̃CN[ht@C
#include "myvst3.h"

// ===================================================================================
// DLLt@C̏AI֐
// ===================================================================================
bool InitModule() { return true; }
bool DeinitModule() { return true; }

// ===================================================================================
// VSTvOC̐
// ===================================================================================
BEGIN_FACTORY_DEF(MYVST_VENDOR, MYVST_URL, MYVST_EMAIL)

	// MyVSTProcessorNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ProcessorUID),
	PClassInfo::kManyInstances,
	kVstAudioEffectClass,
	MYVST_VSTNAME,
	Vst::kDistributable,
	MYVST_SUBCATEGORIES,
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTProcessor::createInstance)

	// MyVSTControllerNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ControllerUID),
	PClassInfo::kManyInstances,
	kVstComponentControllerClass,
	MYVST_VSTNAME " Controller",// VST̖O"Controller"t^́B
	0,                          // gȂ̂ŕK0ɂ
	"",                         // gȂ̂ŕK""ɂ
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTController::createInstance)

END_FACTORY

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// ===================================================================================
// MProcessorNX
// ===================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷(K{)
	setControllerClass(ControllerUID);
}

// NX֐
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{(K{)
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂ݒ
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		addEventInput(STR16("EvntInput"));
	}

	// kResultTrueԂB
	return result;
}


tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// p[^[ύX̏
	if (data.inputParameterChanges != nullptr)
	{
		// ύXꂽp[^[̐擾A̕
		int32 paramChangeCount = data.inputParameterChanges->getParameterCount();
		for (int32 i = 0; i < paramChangeCount; i++)
		{
			// p[^[ύX̃L[擾
			IParamValueQueue* queue = data.inputParameterChanges->getParameterData(i);
			if (queue != nullptr)
			{
				// ǂ̃p[^[ύXꂽm邽߁Ap[^[^O擾
				int32 tag = queue->getParameterId();

				// ύXꂽ񐔂擾
				int32 valueChangeCount = queue->getPointCount();

				// ŌɕύXꂽl擾
				ParamValue value;
				int32 sampleOffset;
				if (queue->getPoint(valueChangeCount - 1, sampleOffset, value) == kResultTrue)
				{
					// tagɉ{
					switch (tag)
					{
					case PITCHBEND:
						pitchbend = 2.0 * value - 1.0; // -1.0`1.0͈̔͂ɂ
						break;
					}
				}
			}
		}
	}

	// Cxg̏
	IEventList* eventList = data.inputEvents;
	if (eventList != nullptr)
	{
		// Cxg̐擾B
		int32 numEvent = eventList->getEventCount();
		for (int32 i = 0; i < numEvent; i++)
		{
			// iԖڂ̃Cxgf[^擾
			Event event;
			if (eventList->getEvent(i, event) == kResultOk)
			{
				int16 channel;
				int16 noteNo;
				float velocity;

				// Cxgf[^̃^CvƂɐU蕪
				switch (event.type)
				{
				case Event::kNoteOnEvent: // m[gICxg̏ꍇ
					channel = event.noteOn.channel;
					noteNo = event.noteOn.pitch;
					velocity = event.noteOn.velocity;

					onNoteOn(channel, noteNo, velocity); // MIDIm[gȈ

					break;

				case Event::kNoteOffEvent: // m[gItCxg̏ꍇ
					channel = event.noteOff.channel;
					noteNo = event.noteOff.pitch;
					velocity = event.noteOff.velocity;

					onNoteOff(channel, noteNo, velocity); // MIDIm[gIt̏
					break;
				}
			}
		}
	}

	// ͂Əo͂`FbN
	if (data.numOutputs != 1)
	{
		return kResultTrue;
	}

	if (data.outputs[0].numChannels != 2)
	{
		return kResultTrue;
	}

	// ́Eo̓obt@̃|C^킩₷ϐɊi[
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		// Xg̃TCY0łȂꍇA
		if (noteList.size() > 0)
		{
			// ŌɉꂽMIDIm[g特(g)vZ
			int lastnote = noteList[noteList.size() - 1];
			pitch = (440.0 * pow(2.0, (double)(lastnote - 69) / 12.0));

			// ʂXɏグ
			volume += 0.01;
			if (volume > 1.0) { volume = 1.0; }
		}
		else
		{
			volume -= 0.001;
			if (volume < 0.0) { volume = 0.0; }
		}

		// sb`xh̏s
		double bendrange = 2.0;
		double bend = pow(2.0, bendrange * pitchbend / 12.0);

		// pxƂɉɉpx
		theta += (2.0 * 3.14159265 * pitch * bend) / 44100.0;

		// o̓obt@Ƀf[^ށB
		// (傫Ȃ肷Ȃ悤AŜ0.3ĂB)
		Sample32 out = (Sample32)(0.3 * volume * sin(theta));
		outL[i] = out;
		outR[i] = out;
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}

void MyVSTProcessor::onNoteOn(int channel, int note, float velocity)
{
	// MIDIm[gICxg̏s
	// ȒPȃTvȂ̂ŁAchannelvelocity͖

	// noteList̍Ōɒǉ
	noteList.push_back(note);
}

void MyVSTProcessor::onNoteOff(int channel, int note, float velocity)
{
	// MIDIm[gItCxg̏s
	// ȒPȃTvȂ̂ŁAchannelvelocity͖

	// noteListŏ猟Anoteɍv̂폜
	for (int i = 0; i < (int)noteList.size(); i++)
	{
		if (noteList[i] == note)
		{
			noteList.erase(noteList.begin() + i);
			break;
		}
	}
}

// ===================================================================================
// VST̃p[^[𐧌䂷邽߂ControllerNX
// ===================================================================================

// NX֐(K{)
tresult PLUGIN_API MyVSTController::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = EditController::initialize(context);
	if (result == kResultTrue)
	{
		// Kv΂̌AŗL̏{B
		RangeParameter* param = new RangeParameter(STR16("PitchBend"), PITCHBEND, STR16(""), -1.0, 1.0, 0.0);
		parameters.addParameter(param);
	}

	// kResultTrueԂB
	return result;
}

// MIDIPitchBendControlChangeƃp[^֘At֐
tresult PLUGIN_API MyVSTController::getMidiControllerAssignment(int32 busIndex, int16 channel, CtrlNumber midiControllerNumber, ParamID& id)
{
	// midiControllerNumberƃp[^ID֌Wt
	switch (midiControllerNumber)
	{
	case kPitchBend:
		id = PITCHBEND;
		return kResultTrue;
	}

	return kResultFalse;
}

} } // namespace SteinbergVst̏I
